<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RentacarElement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RentacarElement extends AbstractStructArrayBase
{
    /**
     * The RentacarElement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RentacarElement[]
     */
    public $RentacarElement;
    /**
     * Constructor method for ArrayOfJP_RentacarElement
     * @uses ArrayOfJP_RentacarElement::setRentacarElement()
     * @param \StructType\JP_RentacarElement[] $rentacarElement
     */
    public function __construct(array $rentacarElement = array())
    {
        $this
            ->setRentacarElement($rentacarElement);
    }
    /**
     * Get RentacarElement value
     * @return \StructType\JP_RentacarElement[]|null
     */
    public function getRentacarElement()
    {
        return $this->RentacarElement;
    }
    /**
     * This method is responsible for validating the values passed to the setRentacarElement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRentacarElement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRentacarElementForArrayConstraintsFromSetRentacarElement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_RentacarElementRentacarElementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RentacarElementRentacarElementItem instanceof \StructType\JP_RentacarElement) {
                $invalidValues[] = is_object($arrayOfJP_RentacarElementRentacarElementItem) ? get_class($arrayOfJP_RentacarElementRentacarElementItem) : sprintf('%s(%s)', gettype($arrayOfJP_RentacarElementRentacarElementItem), var_export($arrayOfJP_RentacarElementRentacarElementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RentacarElement property can only contain items of type \StructType\JP_RentacarElement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RentacarElement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarElement[] $rentacarElement
     * @return \ArrayType\ArrayOfJP_RentacarElement
     */
    public function setRentacarElement(array $rentacarElement = array())
    {
        // validation for constraint: array
        if ('' !== ($rentacarElementArrayErrorMessage = self::validateRentacarElementForArrayConstraintsFromSetRentacarElement($rentacarElement))) {
            throw new \InvalidArgumentException($rentacarElementArrayErrorMessage, __LINE__);
        }
        $this->RentacarElement = $rentacarElement;
        return $this;
    }
    /**
     * Add item to RentacarElement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarElement $item
     * @return \ArrayType\ArrayOfJP_RentacarElement
     */
    public function addToRentacarElement(\StructType\JP_RentacarElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RentacarElement) {
            throw new \InvalidArgumentException(sprintf('The RentacarElement property can only contain items of type \StructType\JP_RentacarElement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RentacarElement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RentacarElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RentacarElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RentacarElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RentacarElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RentacarElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RentacarElement
     */
    public function getAttributeName()
    {
        return 'RentacarElement';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_RentacarElement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
